package de.unisb.prog.typestate;

import java.io.InputStream;
import java.util.List;

import org.apache.log4j.Logger;

/**
 * This is a dummy cache implementation, which does exactly nothing but logging.
 * @author mikerofone
 *
 */
public class DummyCacheLogic implements ICacheLogic {

	Logger log;
	
	public DummyCacheLogic(ICacheProvider cache) {
		// throw away the argument, as we'll never use it
	}

	public DummyCacheLogic() {
	}

	public void cacheResults(IMethodIdentifier method, List<IViolationPoint> resultSet) {
		if (log != null)
			log.trace(String.format("DummyCacheLogic: cacheResults(%s, %s)",method, resultSet));
	}

	public List<IViolationPoint> getCachedResults(IMethodIdentifier method) {
		if (log != null)
			log.trace(String.format("DummyCacheLogic: getCachedResults(%s) - returning null",method));
		return null;
	}

	public boolean hasCachedEntry(IMethodIdentifier method) {
		if (log != null)
			log.trace(String.format("DummyCacheLogic: hasCachedEntry(%s) - returning false",method));
		return false;
	}

	public void setLogger(Logger logger) {
		log = logger;
		if (log != null)
			log.trace(String.format("DummyCacheLogic: setLogger(%s)",logger));
	}

	public void useClass(InputStream classCode) {
		if (log != null)
			log.trace(String.format("DummyCacheLogic: useClass(%s)",classCode));
	}

}
