package de.unisb.prog.typestate;

import org.apache.log4j.Logger;

/**
 * Classes implementing this interface can be used to start the analysis and return the results. They are the
 * entry point for integration of the analysis into other programs.
 * 
 * @author mikerofone
 * 
 */
public interface IAnalysis {

	/**
	 * Runs the analysis on the given {@link IInputDataSet} and returns the {@link IAnalysisResults} afterwards.
	 * @param inputData	The input data set.
	 * @param A logger which is used for - guess what - logging.
	 * @return The analysis results,
	 * @throws InterruptedException 
	 */
	public IAnalysisResults run(IInputDataSet inputData, Logger logger);
	
}
