package de.unisb.prog.typestate;

import de.unisb.prog.jfirm.ir.Type;

/**
 * Provides specifications for types.
 * 
 * @author mikerofone
 * 
 */
public interface ISpecificationRepository {
	
	/**
	 * Returns a {@link Specification} for the given type, if known.
	 * @param type the requested jFirm type object
	 * @return the {@link Specification}, if available, or <code>null</code> if not
	 */
	public Specification getSpecification(Type type);
}
