package de.unisb.prog.typestate;

import de.unisb.prog.typestate.util.Types;

public class MethodIdentifier implements IMethodIdentifier {

	String methodName, signature, inClass;
	public MethodIdentifier(String methodName, String signature, String inClass) {
		this.methodName = methodName;
		this.signature = signature;
		this.inClass = inClass;
	}

	public MethodIdentifier(String methodBytecodeName) {
		this.methodName = Types.methodName(methodBytecodeName);
		this.signature = Types.paramRetTypes(methodBytecodeName);
		this.inClass = Types.getClassName(methodBytecodeName);
	}

	public String getClassName() {
		return inClass;
	}

	public String getMethodName() {
		return methodName;
	}

	public String getSignature() {
		return signature;
	}

	public String getMethodId() {
		return inClass + "." + methodName + signature;
	}

}
