package de.unisb.prog.typestate;

import edu.uci.ics.jung.graph.DirectedGraph;

public class TypeStateAutomaton implements ITypeStateAutomaton {

	String name, initState, errorState;
	
	DirectedGraph<String, ITransition> graph;
	
	public TypeStateAutomaton(String className, DirectedGraph<String, ITransition> graph, String initState, String errorState) {
		if (className == null || graph == null || initState == null  || errorState == null) {
			throw new IllegalArgumentException(String.format("One or more parameters of constructor are null: %s %s %s %s", className, graph, initState, errorState));
		}
		if (!graph.containsVertex(initState) || !graph.containsVertex(errorState)) {
			//Init&Error state must be in the graph
			throw new IllegalArgumentException(String.format("initState (%s) or errorState (%) are not contained in the graph.", initState, errorState));
		}
		name = className;
		this.graph = graph;
		this.errorState = errorState;
		this.initState = initState;
	}

	public DirectedGraph<String, ITransition> getAutomaton() {
		return graph;	}

	public String getErrorState() {
		return errorState;
	}

	public String getInitState() {
		return initState;
	}

	public String getName() {
		return name;
	}

}
