/**
 * 
 */
package de.unisb.prog.typestate.io;

import org.softevo.util.asm.MethodIdentifier;

import de.unisb.prog.typestate.IMethodIdentifier;

public class MethodIdentifierWrapper implements IMethodIdentifier {

	private MethodIdentifier identifier;
	
	private String methodId;

	public MethodIdentifierWrapper(MethodIdentifier identifier) {
		this.identifier = identifier;
		this.methodId = identifier.getMethodName() + identifier.getSignature();
	}
		
	public String getClassName() {
		return identifier.getClassName();
	}

	public String getMethodId() {
		return methodId;
	}

	public String getMethodName() {
		return identifier.getMethodName();
	}

	public String getSignature() {
		return identifier.getSignature();
	}
	
	@Override
	public boolean equals(Object object) {
		if (object != null && object instanceof IMethodIdentifier) {
			IMethodIdentifier anotherIdentifier = (IMethodIdentifier) object;
			return anotherIdentifier.getClassName().equals(getClassName()) && 
			anotherIdentifier.getMethodName().equals(getMethodName()) && 
			anotherIdentifier.getSignature().equals(getSignature());
		} else {
			return false;
		}
	}
	
	@Override
	public int hashCode() {
		return identifier.hashCode();
	}
}