package de.unisb.prog.typestate.ir;

import de.unisb.prog.analysis.ContextAndNode;
import de.unisb.prog.jfirm.ir.Cast;
import de.unisb.prog.jfirm.ir.DataMemExec;
import de.unisb.prog.jfirm.ir.Mode;
import de.unisb.prog.jfirm.ir.ValueNode;
import de.unisb.prog.typestate.AnalysisLogger;
import de.unisb.prog.typestate.ir.FirmWalker.Globals;

public class CastHandler {

	private Globals	g;

	public void init(Globals g) {
		this.g = g;
	}

	/**
	 * A cast creates a reference to some object but only changes the type. TODO: extend handling when types
	 * are available.
	 */
	public ValueNode handleCast(Cast cast) {
		// Only care about reference type inputs
		//HACK: Completely ignore casts
		if (AnalysisLogger.getInstance().debug()) {
			AnalysisLogger.getInstance().debug("CAST HACK: skipping " + cast + " while walking down Firm graph");
		}
//		ValueNode value = cast.getValue(DataMemExec.DATA);
//		if (value.getMode() == Mode.A) {
//			ContextAndNode projDataNode = new ContextAndNode(g.context, cast);
//
//			// Create a (new) Reference Node for this getField which stores the current state of the instance
//			// and which is linked to all allocation sites which this getField can reach
//			g.methodMem.makeReference(projDataNode, null);
//		}

		return cast.getValue(DataMemExec.MEM);
	}
}
