package de.unisb.prog.typestate.ir;

import java.util.Iterator;
import java.util.NoSuchElementException;

import de.unisb.prog.analysis.ContextAndNode;
import de.unisb.prog.pointsto.PointsToSet;

public class EmptyPointsToSet extends PointsToSet {

	private static final Iterator<ContextAndNode>	EMPTY_ITER	= new Iterator<ContextAndNode>() {

																	public boolean hasNext() {
																		return false;
																	}

																	public ContextAndNode next() {
																		throw new NoSuchElementException(
																				"EmptyIterator never contains elements");
																	}

																	public void remove() {
																		throw new UnsupportedOperationException(
																				"EmptyIterator cannot remove");

																	}
																};
	private static EmptyPointsToSet					instance;

	private EmptyPointsToSet() {
	}

	@Override
	protected boolean addNode(ContextAndNode node) {
		return false;
	}

	@Override
	public Iterator<ContextAndNode> iterator() {
		return EMPTY_ITER;
	}

	public static EmptyPointsToSet getInstance() {
		if (instance == null) {
			instance = new EmptyPointsToSet();
		}
		return instance;
	}

	@Override
	public int size() {
		return 0;
	}
}
