package de.unisb.prog.typestate.ir;

import de.unisb.prog.analysis.ContextAndNode;
import de.unisb.prog.jfirm.ir.Type.ClassType.Field;

public class FieldID {
	private Field		field;
	private ContextAndNode	ofObj;

	protected FieldID(Field field) {
		this.field = field;
		ofObj = null;
	}

	public FieldID(Field field, ContextAndNode ofObj) {
		this.field = field;
		this.ofObj = ofObj;
	}

	public boolean isStatic() {
		return ofObj == null;
	}

	public Field getField() {
		return field;
	}
	
	public ContextAndNode getObj() {
		return ofObj;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((this.field == null) ? 0 : this.field.hashCode());
		result = prime * result + ((this.ofObj == null) ? 0 : this.ofObj.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj instanceof FieldID) {
			FieldID other = (FieldID) obj;
			return field.equals(other.field) && (ofObj==null?other.ofObj == null : ofObj.equals(other.ofObj));
		} else {
			return false;
		}
	}

	@Override
	public String toString() {
		return field.getType() + " " + (ofObj==null? "S " + field.getOwner() : ofObj.toString()) + "." + field.getName(); 
	}
	
}
