package de.unisb.prog.typestate.ir.oldstuff;

import java.util.Set;

import de.unisb.prog.typestate.ir.AllocSite;

public interface IAliasResolver {

	/**
	 * Return all allocation sites in the <code>potentialAliases</code> set which alias with any of the
	 * allocation sites contained in the <code>sources</code> set.
	 * 
	 * @param sources the allocation sites whose aliases are to be found
	 * @param potentialAliases the allocation sites which are assumed to alias with any of the sites in <code>sources</code>
	 * @return all allocation sites from <code>potentialAliases</code> which (might) alias with any of the <code>sources</code> sites
	 */
	public IAliasInfo getAliasingAllocs(Set<AllocSite> sources, Set<AllocSite> potentialAliases);

}
