package de.unisb.prog.typestate.util;

import de.unisb.prog.jfirm.ir.Param;
import de.unisb.prog.jfirm.ir.ValueNode;

public class ParamHelper {
	/**
	 * Parses the parameter index (-> counting <strong>formal</strong> parameters to the method, excluding the
	 * memory "parameter") from the name of the given {@link Param}. The name is expected to contain the
	 * parameter index as the first space-separated number (esp. before the jFirm node id). This is unsafe and
	 * erroneous and is only used for debugging.
	 * 
	 * @param param
	 * @return the formal index of the parameter (adding 1 gives the index of the parameter in the jFirm
	 *         perspective, including mem as parameter)
	 */
	@Deprecated
	public static int parseParamIndex(Param param) {
		int pIndex = -1;
		// FIXME make use of the "getParams"-thingy when available
		for (String part : param.toString().split(" ")) {
			try {
				pIndex = Integer.valueOf(part);
				break;
			} catch (NumberFormatException e) {
				// next
			}
		}
		if (pIndex == -1) {
			throw new IllegalArgumentException("ParamHelper.parseParamIndex(" + param
					+ "): Param Node as parameter with illegal name (contains no number)");
		}
		return pIndex;
	}

	/**
	 * Finds the given {@link Param} in the given list of method parameters and returns the appropriate array
	 * index.
	 * 
	 * @param param the {@link Param} whose index is to be found
	 * @param methodParamList the list of all parameters for the method (including memory)
	 * @return the index of <code>param</code> in the array or <code>-1</code>, if not found.
	 */
	public static int getIndex(Param param, ValueNode[] methodParamList) {
		for (int i = 1, n = methodParamList.length; i < n; i++) {
			if (methodParamList[i] == param)
				return i;
		}
		return -1;

	}
}
