package de.unisb.prog.typestate.violation;

/**
 * Implementation of {@link IViolationInfo} only providing a <code>String</code> representation via the
 * required {@link #toString()} method.
 * 
 * @author mikerofone
 * 
 */
public class GenericStringInfo implements IViolationInfo {

	private String info;
	
	public GenericStringInfo(String info) {
		if (info == null) {
			throw new IllegalArgumentException("GenericStringInfo(null) not allowed");
		}
		this.info = info;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see de.unisb.prog.typestate.violation.IViolationInfo#getType()
	 */
	public InfoType getType() {
		return InfoType.GENERIC_STRING;
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.unisb.prog.typestate.violation.IViolationInfo#text()
	 */
	public String text() {
		return info;
	}
	
	
	

}
